<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - ID Numbers</TITLE>
<link href="suif1_13.html" rel=Next>
<link href="suif1_11.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_11.html">previous</A>, <A HREF="suif1_13.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H3><A NAME="SEC12" HREF="suif1_toc.html#TOC12">ID Numbers for Tree Nodes and Instructions</A></H3>
<P>
<A NAME="IDX27"></A>
<A NAME="IDX28"></A>
<A NAME="IDX29"></A>
<A NAME="IDX30"></A>
<A NAME="IDX31"></A>

</P>
<P>
<A NAME="IDX32"></A>
Within each procedure, the tree nodes and instructions are assigned
unique ID numbers.  These numbers can be used to identify the nodes and
instructions internally and in annotations that are written to the
output files.  The <CODE>number</CODE> method retrieves the ID numbers.  It is
generally best to avoid using the numbers on <CODE>tree_instr</CODE> nodes,
because they are not written to the output files and the
<CODE>tree_instr</CODE> nodes are automatically rearranged when converting
between expression trees and flat lists of instructions.  Instead, use
the ID numbers for the corresponding instructions.

</P>
<P>
<A NAME="IDX33"></A>
<A NAME="IDX34"></A>
<A NAME="IDX35"></A>
The <CODE>number_instrs</CODE> method in the <CODE>tree_proc</CODE> class assigns ID
numbers to tree nodes and instructions that do yet have numbers (i.e.
those that were created since the procedure was read in).  This method
is called automatically before each procedure is written out, but you
may also call it whenever ID numbers are needed for new tree nodes or
instructions.  The next unused ID number is recorded in the procedure
symbol table.  In the <CODE>proc_symtab</CODE> class, the
<CODE>next_instr_num</CODE> method returns the next ID number and increments
the counter; the <CODE>instr_num</CODE> method returns the next number but
does not increment the counter.  Since you can only assign new ID
numbers with the <CODE>number_instrs</CODE> method, you will rarely, if ever,
need to access this counter directly.

</P>
<P>
<A NAME="IDX36"></A>
<A NAME="IDX37"></A>
<A NAME="IDX38"></A>
In some circumstances, the tree node and instruction ID numbers must be
reset.  The most common case is when moving code from one procedure to
another.  Since the ID numbers are only unique within each procedure,
moving things between procedures is likely to create duplicate ID
numbers.  To avoid this problem, the <CODE>tree_node</CODE>,
<CODE>tree_node_list</CODE>, and <CODE>instruction</CODE> classes provide
<CODE>clear_numbers</CODE> methods to reset the ID numbers.  These methods
recursively descend the ASTs and expression trees to set all of the ID
numbers within the object and its children to zero.

</P>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_11.html">previous</A>, <A HREF="suif1_13.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
